/* This file has been generated by the Perl script `afblue.pl', */
/* using data from file `afblue.dat'.                           */

/***************************************************************************/
/*                                                                         */
/*  afblue.h                                                               */
/*                                                                         */
/*    Auto-fitter data for blue strings (specification).                   */
/*                                                                         */
/*  Copyright 2013-2017 by                                                 */
/*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
/*                                                                         */
/*  This file is part of the FreeType project, and may only be used,       */
/*  modified, and distributed under the terms of the FreeType project      */
/*  license, LICENSE.TXT.  By continuing to use, modify, or distribute     */
/*  this file you indicate that you have read the license and              */
/*  understand and accept it fully.                                        */
/*                                                                         */
/***************************************************************************/


#ifndef AFBLUE_H_
#define AFBLUE_H_


FT_BEGIN_HEADER


  /* an auxiliary macro to decode a UTF-8 character -- since we only use */
  /* hard-coded, self-converted data, no error checking is performed     */
#define GET_UTF8_CHAR( ch, p )                      \
          do                                        \
          {                                         \
            ch = (unsigned char)*p++;               \
            if ( ch >= 0x80 )                       \
            {                                       \
              FT_UInt  len_;                        \
                                                    \
                                                    \
              if ( ch < 0xE0 )                      \
              {                                     \
                len_ = 1;                           \
                ch  &= 0x1F;                        \
              }                                     \
              else if ( ch < 0xF0 )                 \
              {                                     \
                len_ = 2;                           \
                ch  &= 0x0F;                        \
              }                                     \
              else                                  \
              {                                     \
                len_ = 3;                           \
                ch  &= 0x07;                        \
              }                                     \
                                                    \
              for ( ; len_ > 0; len_-- )            \
                ch = ( ch << 6 ) | ( *p++ & 0x3F ); \
            }                                       \
          } while ( 0 )


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                    B L U E   S T R I N G S                    *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* At the bottommost level, we define strings for finding blue zones. */


#define AF_BLUE_STRING_MAX_LEN  51

  /* The AF_Blue_String enumeration values are offsets into the */
  /* `af_blue_strings' array.                                   */

  typedef enum  AF_Blue_String_
  {
    AF_BLUE_STRING_ADLAM_CAPITAL_TOP = 0,
    AF_BLUE_STRING_ADLAM_CAPITAL_BOTTOM = 30,
    AF_BLUE_STRING_ADLAM_SMALL_TOP = 40,
    AF_BLUE_STRING_ADLAM_SMALL_BOTTOM = 65,
    AF_BLUE_STRING_ARABIC_TOP = 105,
    AF_BLUE_STRING_ARABIC_BOTTOM = 123,
    AF_BLUE_STRING_ARABIC_JOIN = 138,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_TOP = 141,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_BOTTOM = 165,
    AF_BLUE_STRING_ARMENIAN_SMALL_ASCENDER = 189,
    AF_BLUE_STRING_ARMENIAN_SMALL_TOP = 210,
    AF_BLUE_STRING_ARMENIAN_SMALL_BOTTOM = 234,
    AF_BLUE_STRING_ARMENIAN_SMALL_DESCENDER = 258,
    AF_BLUE_STRING_AVESTAN_TOP = 282,
    AF_BLUE_STRING_AVESTAN_BOTTOM = 302,
    AF_BLUE_STRING_BAMUM_TOP = 312,
    AF_BLUE_STRING_BAMUM_BOTTOM = 344,
    AF_BLUE_STRING_BENGALI_BASE = 376,
    AF_BLUE_STRING_BENGALI_TOP = 408,
    AF_BLUE_STRING_BENGALI_HEAD = 436,
    AF_BLUE_STRING_BUHID_TOP = 468,
    AF_BLUE_STRING_BUHID_LARGE = 476,
    AF_BLUE_STRING_BUHID_SMALL = 488,
    AF_BLUE_STRING_BUHID_BOTTOM = 504,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_TOP = 532,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_BOTTOM = 564,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_TOP = 596,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_BOTTOM = 628,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_TOP = 660,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_BOTTOM = 688,
    AF_BLUE_STRING_CARIAN_TOP = 720,
    AF_BLUE_STRING_CARIAN_BOTTOM = 760,
    AF_BLUE_STRING_CHEROKEE_CAPITAL = 795,
    AF_BLUE_STRING_CHEROKEE_SMALL_ASCENDER = 827,
    AF_BLUE_STRING_CHEROKEE_SMALL = 859,
    AF_BLUE_STRING_CHEROKEE_SMALL_DESCENDER = 891,
    AF_BLUE_STRING_COPTIC_CAPITAL_TOP = 907,
    AF_BLUE_STRING_COPTIC_CAPITAL_BOTTOM = 939,
    AF_BLUE_STRING_COPTIC_SMALL_TOP = 971,
    AF_BLUE_STRING_COPTIC_SMALL_BOTTOM = 1003,
    AF_BLUE_STRING_CYPRIOT_TOP = 1035,
    AF_BLUE_STRING_CYPRIOT_BOTTOM = 1075,
    AF_BLUE_STRING_CYPRIOT_SMALL = 1110,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_TOP = 1125,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_BOTTOM = 1149,
    AF_BLUE_STRING_CYRILLIC_SMALL = 1173,
    AF_BLUE_STRING_CYRILLIC_SMALL_DESCENDER = 1197,
    AF_BLUE_STRING_DESERET_CAPITAL_TOP = 1206,
    AF_BLUE_STRING_DESERET_CAPITAL_BOTTOM = 1231,
    AF_BLUE_STRING_DESERET_SMALL_TOP = 1256,
    AF_BLUE_STRING_DESERET_SMALL_BOTTOM = 1281,
    AF_BLUE_STRING_DEVANAGARI_BASE = 1306,
    AF_BLUE_STRING_DEVANAGARI_TOP = 1338,
    AF_BLUE_STRING_DEVANAGARI_HEAD = 1370,
    AF_BLUE_STRING_DEVANAGARI_BOTTOM = 1402,
    AF_BLUE_STRING_ETHIOPIC_TOP = 1410,
    AF_BLUE_STRING_ETHIOPIC_BOTTOM = 1442,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_TOP = 1474,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_BOTTOM = 1506,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_ASCENDER = 1538,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_DESCENDER = 1570,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_TOP = 1602,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_BOTTOM = 1634,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_TOP = 1666,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_BOTTOM = 1698,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_ASCENDER = 1730,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_DESCENDER = 1762,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_TOP = 1794,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_BOTTOM = 1826,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_TOP = 1858,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_BOTTOM = 1890,
    AF_BLUE_STRING_GOTHIC_TOP = 1922,
    AF_BLUE_STRING_GOTHIC_BOTTOM = 1962,
    AF_BLUE_STRING_GREEK_CAPITAL_TOP = 1982,
    AF_BLUE_STRING_GREEK_CAPITAL_BOTTOM = 2003,
    AF_BLUE_STRING_GREEK_SMALL_BETA_TOP = 2021,
    AF_BLUE_STRING_GREEK_SMALL = 2039,
    AF_BLUE_STRING_GREEK_SMALL_DESCENDER = 2063,
    AF_BLUE_STRING_GUJARATI_TOP = 2087,
    AF_BLUE_STRING_GUJARATI_BOTTOM = 2119,
    AF_BLUE_STRING_GUJARATI_ASCENDER = 2151,
    AF_BLUE_STRING_GUJARATI_DESCENDER = 2201,
    AF_BLUE_STRING_GUJARATI_DIGIT_TOP = 2234,
    AF_BLUE_STRING_GURMUKHI_BASE = 2254,
    AF_BLUE_STRING_GURMUKHI_HEAD = 2286,
    AF_BLUE_STRING_GURMUKHI_TOP = 2318,
    AF_BLUE_STRING_GURMUKHI_BOTTOM = 2350,
    AF_BLUE_STRING_GURMUKHI_DIGIT_TOP = 2382,
    AF_BLUE_STRING_HEBREW_TOP = 2402,
    AF_BLUE_STRING_HEBREW_BOTTOM = 2426,
    AF_BLUE_STRING_HEBREW_DESCENDER = 2444,
    AF_BLUE_STRING_KANNADA_TOP = 2459,
    AF_BLUE_STRING_KANNADA_BOTTOM = 2503,
    AF_BLUE_STRING_KHMER_TOP = 2535,
    AF_BLUE_STRING_KHMER_SUBSCRIPT_TOP = 2559,
    AF_BLUE_STRING_KHMER_BOTTOM = 2599,
    AF_BLUE_STRING_KHMER_DESCENDER = 2631,
    AF_BLUE_STRING_KHMER_LARGE_DESCENDER = 2665,
    AF_BLUE_STRING_KHMER_SYMBOLS_WAXING_TOP = 2752,
    AF_BLUE_STRING_KHMER_SYMBOLS_WANING_BOTTOM = 2760,
    AF_BLUE_STRING_LAO_TOP = 2768,
    AF_BLUE_STRING_LAO_BOTTOM = 2800,
    AF_BLUE_STRING_LAO_ASCENDER = 2832,
    AF_BLUE_STRING_LAO_LARGE_ASCENDER = 2848,
    AF_BLUE_STRING_LAO_DESCENDER = 2860,
    AF_BLUE_STRING_LATIN_CAPITAL_TOP = 2884,
    AF_BLUE_STRING_LATIN_CAPITAL_BOTTOM = 2900,
    AF_BLUE_STRING_LATIN_SMALL_F_TOP = 2916,
    AF_BLUE_STRING_LATIN_SMALL_TOP = 2930,
    AF_BLUE_STRING_LATIN_SMALL_BOTTOM = 2946,
    AF_BLUE_STRING_LATIN_SMALL_DESCENDER = 2962,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_TOP = 2972,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_BOTTOM = 2992,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_F_TOP = 3012,
    AF_BLUE_STRING_LATIN_SUBS_SMALL = 3032,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_DESCENDER = 3068,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_TOP = 3088,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_BOTTOM = 3119,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_F_TOP = 3148,
    AF_BLUE_STRING_LATIN_SUPS_SMALL = 3174,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_DESCENDER = 3199,
    AF_BLUE_STRING_LISU_TOP = 3210,
    AF_BLUE_STRING_LISU_BOTTOM = 3242,
    AF_BLUE_STRING_MALAYALAM_TOP = 3274,
    AF_BLUE_STRING_MALAYALAM_BOTTOM = 3318,
    AF_BLUE_STRING_MYANMAR_TOP = 3350,
    AF_BLUE_STRING_MYANMAR_BOTTOM = 3382,
    AF_BLUE_STRING_MYANMAR_ASCENDER = 3414,
    AF_BLUE_STRING_MYANMAR_DESCENDER = 3442,
    AF_BLUE_STRING_NKO_TOP = 3474,
    AF_BLUE_STRING_NKO_BOTTOM = 3498,
    AF_BLUE_STRING_NKO_SMALL_TOP = 3513,
    AF_BLUE_STRING_NKO_SMALL_BOTTOM = 3522,
    AF_BLUE_STRING_OL_CHIKI = 3534,
    AF_BLUE_STRING_OLD_TURKIC_TOP = 3558,
    AF_BLUE_STRING_OLD_TURKIC_BOTTOM = 3573,
    AF_BLUE_STRING_OSAGE_CAPITAL_TOP = 3593,
    AF_BLUE_STRING_OSAGE_CAPITAL_BOTTOM = 3633,
    AF_BLUE_STRING_OSAGE_CAPITAL_DESCENDER = 3663,
    AF_BLUE_STRING_OSAGE_SMALL_TOP = 3678,
    AF_BLUE_STRING_OSAGE_SMALL_BOTTOM = 3718,
    AF_BLUE_STRING_OSAGE_SMALL_ASCENDER = 3758,
    AF_BLUE_STRING_OSAGE_SMALL_DESCENDER = 3783,
    AF_BLUE_STRING_OSMANYA_TOP = 3798,
    AF_BLUE_STRING_OSMANYA_BOTTOM = 3838,
    AF_BLUE_STRING_SAURASHTRA_TOP = 3878,
    AF_BLUE_STRING_SAURASHTRA_BOTTOM = 3910,
    AF_BLUE_STRING_SHAVIAN_TOP = 3930,
    AF_BLUE_STRING_SHAVIAN_BOTTOM = 3940,
    AF_BLUE_STRING_SHAVIAN_DESCENDER = 3965,
    AF_BLUE_STRING_SHAVIAN_SMALL_TOP = 3975,
    AF_BLUE_STRING_SHAVIAN_SMALL_BOTTOM = 4010,
    AF_BLUE_STRING_SINHALA_TOP = 4025,
    AF_BLUE_STRING_SINHALA_BOTTOM = 4057,
    AF_BLUE_STRING_SINHALA_DESCENDER = 4089,
    AF_BLUE_STRING_SUNDANESE_TOP = 4133,
    AF_BLUE_STRING_SUNDANESE_BOTTOM = 4157,
    AF_BLUE_STRING_SUNDANESE_DESCENDER = 4189,
    AF_BLUE_STRING_TAI_VIET_TOP = 4197,
    AF_BLUE_STRING_TAI_VIET_BOTTOM = 4217,
    AF_BLUE_STRING_TAMIL_TOP = 4229,
    AF_BLUE_STRING_TAMIL_BOTTOM = 4261,
    AF_BLUE_STRING_TELUGU_TOP = 4293,
    AF_BLUE_STRING_TELUGU_BOTTOM = 4321,
    AF_BLUE_STRING_THAI_TOP = 4349,
    AF_BLUE_STRING_THAI_BOTTOM = 4373,
    AF_BLUE_STRING_THAI_ASCENDER = 4401,
    AF_BLUE_STRING_THAI_LARGE_ASCENDER = 4413,
    AF_BLUE_STRING_THAI_DESCENDER = 4425,
    AF_BLUE_STRING_THAI_LARGE_DESCENDER = 4441,
    AF_BLUE_STRING_THAI_DIGIT_TOP = 4449,
    AF_BLUE_STRING_TIFINAGH = 4461,
    AF_BLUE_STRING_VAI_TOP = 4493,
    AF_BLUE_STRING_VAI_BOTTOM = 4525,
    af_blue_1_1 = 4556,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRING_CJK_TOP = af_blue_1_1 + 1,
    AF_BLUE_STRING_CJK_BOTTOM = af_blue_1_1 + 203,
    af_blue_1_1_1 = af_blue_1_1 + 404,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    AF_BLUE_STRING_CJK_LEFT = af_blue_1_1_1 + 1,
    AF_BLUE_STRING_CJK_RIGHT = af_blue_1_1_1 + 204,
    af_blue_1_1_2 = af_blue_1_1_1 + 405,
#else
    af_blue_1_1_2 = af_blue_1_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_1_2 = af_blue_1_1_2 + 0,
#else
    af_blue_1_2 = af_blue_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRING_MAX   /* do not remove */

  } AF_Blue_String;


  FT_LOCAL_ARRAY( char )
  af_blue_strings[];


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                 B L U E   S T R I N G S E T S                 *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* The next level is to group blue strings into style-specific sets. */


  /* Properties are specific to a writing system.  We assume that a given  */
  /* blue string can't be used in more than a single writing system, which */
  /* is a safe bet.                                                        */
#define AF_BLUE_PROPERTY_LATIN_TOP       ( 1U << 0 )  /* must have value 1 */
#define AF_BLUE_PROPERTY_LATIN_SUB_TOP   ( 1U << 1 )
#define AF_BLUE_PROPERTY_LATIN_NEUTRAL   ( 1U << 2 )
#define AF_BLUE_PROPERTY_LATIN_X_HEIGHT  ( 1U << 3 )
#define AF_BLUE_PROPERTY_LATIN_LONG      ( 1U << 4 )

#define AF_BLUE_PROPERTY_CJK_TOP    ( 1U << 0 )       /* must have value 1 */
#define AF_BLUE_PROPERTY_CJK_HORIZ  ( 1U << 1 )       /* must have value 2 */
#define AF_BLUE_PROPERTY_CJK_RIGHT  AF_BLUE_PROPERTY_CJK_TOP


#define AF_BLUE_STRINGSET_MAX_LEN  8

  /* The AF_Blue_Stringset enumeration values are offsets into the */
  /* `af_blue_stringsets' array.                                   */

  typedef enum  AF_Blue_Stringset_
  {
    AF_BLUE_STRINGSET_ADLM = 0,
    AF_BLUE_STRINGSET_ARAB = 5,
    AF_BLUE_STRINGSET_ARMN = 9,
    AF_BLUE_STRINGSET_AVST = 16,
    AF_BLUE_STRINGSET_BAMU = 19,
    AF_BLUE_STRINGSET_BENG = 22,
    AF_BLUE_STRINGSET_BUHD = 27,
    AF_BLUE_STRINGSET_CANADIAN_SYLLABICS = 32,
    AF_BLUE_STRINGSET_CARI = 39,
    AF_BLUE_STRINGSET_CHER = 42,
    AF_BLUE_STRINGSET_COPT = 49,
    AF_BLUE_STRINGSET_CPRT = 54,
    AF_BLUE_STRINGSET_CYRL = 59,
    AF_BLUE_STRINGSET_DEVA = 65,
    AF_BLUE_STRINGSET_DSRT = 71,
    AF_BLUE_STRINGSET_ETHI = 76,
    AF_BLUE_STRINGSET_GEOR = 79,
    AF_BLUE_STRINGSET_GEOK = 84,
    AF_BLUE_STRINGSET_GLAG = 91,
    AF_BLUE_STRINGSET_GOTH = 96,
    AF_BLUE_STRINGSET_GREK = 99,
    AF_BLUE_STRINGSET_GUJR = 106,
    AF_BLUE_STRINGSET_GURU = 112,
    AF_BLUE_STRINGSET_HEBR = 118,
    AF_BLUE_STRINGSET_KNDA = 122,
    AF_BLUE_STRINGSET_KHMR = 125,
    AF_BLUE_STRINGSET_KHMS = 131,
    AF_BLUE_STRINGSET_LAO = 134,
    AF_BLUE_STRINGSET_LATN = 140,
    AF_BLUE_STRINGSET_LATB = 147,
    AF_BLUE_STRINGSET_LATP = 154,
    AF_BLUE_STRINGSET_LISU = 161,
    AF_BLUE_STRINGSET_MLYM = 164,
    AF_BLUE_STRINGSET_MYMR = 167,
    AF_BLUE_STRINGSET_NKOO = 172,
    AF_BLUE_STRINGSET_NONE = 177,
    AF_BLUE_STRINGSET_OLCK = 178,
    AF_BLUE_STRINGSET_ORKH = 181,
    AF_BLUE_STRINGSET_OSGE = 184,
    AF_BLUE_STRINGSET_OSMA = 192,
    AF_BLUE_STRINGSET_SAUR = 195,
    AF_BLUE_STRINGSET_SHAW = 198,
    AF_BLUE_STRINGSET_SINH = 204,
    AF_BLUE_STRINGSET_SUND = 208,
    AF_BLUE_STRINGSET_TAML = 212,
    AF_BLUE_STRINGSET_TAVT = 215,
    AF_BLUE_STRINGSET_TELU = 218,
    AF_BLUE_STRINGSET_THAI = 221,
    AF_BLUE_STRINGSET_TFNG = 229,
    AF_BLUE_STRINGSET_VAII = 232,
    af_blue_2_1 = 235,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRINGSET_HANI = af_blue_2_1 + 0,
    af_blue_2_1_1 = af_blue_2_1 + 2,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    af_blue_2_1_2 = af_blue_2_1_1 + 2,
#else
    af_blue_2_1_2 = af_blue_2_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_2_2 = af_blue_2_1_2 + 1,
#else
    af_blue_2_2 = af_blue_2_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRINGSET_MAX   /* do not remove */

  } AF_Blue_Stringset;


  typedef struct  AF_Blue_StringRec_
  {
    AF_Blue_String  string;
    FT_UShort       properties;

  } AF_Blue_StringRec;


  FT_LOCAL_ARRAY( AF_Blue_StringRec )
  af_blue_stringsets[];

/* */

FT_END_HEADER


#endif /* AFBLUE_H_ */


/* END */
